searchNodes=[{"ref":"Category.html","title":"Category","type":"module","doc":"Functors, monads, applicatives"},{"ref":"Category.Data.html","title":"Category.Data","type":"module","doc":""},{"ref":"Category.Data.Maybe.html","title":"Category.Data.Maybe","type":"module","doc":"Classic sum type Maybe Implements Monad, Functor and Applicative behaviours"},{"ref":"Category.Data.Maybe.html#get/1","title":"Category.Data.Maybe.get/1","type":"function","doc":"If argument is just(a) then returns a, otherwise returns nil Examples iex&gt; j = Maybe.just(1) iex&gt; n = Maybe.nothing() iex&gt; Maybe.get(j) 1 iex&gt; Maybe.get(n) nil"},{"ref":"Category.Data.Maybe.html#get!/1","title":"Category.Data.Maybe.get!/1","type":"function","doc":"If argument is just(a) then returns a, otherwise raise exception Examples iex&gt; j = Maybe.just(1) iex&gt; n = Maybe.nothing() iex&gt; Maybe.get!(j) 1 iex&gt; Maybe.get!(n) ** (RuntimeError) Can&#39;t get! from Category.Data.Maybe.nothing"},{"ref":"Category.Data.Maybe.html#is?/1","title":"Category.Data.Maybe.is?/1","type":"function","doc":"Accepts any term Returns true if term is value of Category.Data.Maybe λ-type, otherwise returns false"},{"ref":"Category.Data.Maybe.html#is_just?/1","title":"Category.Data.Maybe.is_just?/1","type":"function","doc":"If argument is just(a) then returns true If argument is nothing() then returns false Otherwise raise exception Examples iex&gt; j = Maybe.just(1) iex&gt; n = Maybe.nothing() iex&gt; Maybe.is_just?(j) true iex&gt; Maybe.is_just?(n) false"},{"ref":"Category.Data.Maybe.html#is_nothing?/1","title":"Category.Data.Maybe.is_nothing?/1","type":"function","doc":"If argument is nothing() then returns true If argument is just(a) then returns false Otherwise raise exception Examples iex&gt; j = Maybe.just(1) iex&gt; n = Maybe.nothing() iex&gt; Maybe.is_nothing?(n) true iex&gt; Maybe.is_nothing?(j) false"},{"ref":"Category.Data.Maybe.html#just/1","title":"Category.Data.Maybe.just/1","type":"function","doc":"First constructor Examples iex&gt; x = Maybe.just(1) iex&gt; Maybe.is_just?(x) true"},{"ref":"Category.Data.Maybe.html#nothing/0","title":"Category.Data.Maybe.nothing/0","type":"function","doc":"Second constructor Examples iex&gt; x = Maybe.nothing() iex&gt; Maybe.is_nothing?(x) true"},{"ref":"Category.Data.Maybe.html#t:t/1","title":"Category.Data.Maybe.t/1","type":"opaque","doc":""},{"ref":"Category.TypeClass.html","title":"Category.TypeClass","type":"module","doc":""},{"ref":"Category.TypeClass.html#define_using/0","title":"Category.TypeClass.define_using/0","type":"macro","doc":""},{"ref":"Category.TypeClass.Applicative.html","title":"Category.TypeClass.Applicative","type":"behaviour","doc":""},{"ref":"Category.TypeClass.Applicative.html#<<~/2","title":"Category.TypeClass.Applicative.<<~/2","type":"macro","doc":""},{"ref":"Category.TypeClass.Applicative.html#ap/2","title":"Category.TypeClass.Applicative.ap/2","type":"macro","doc":""},{"ref":"Category.TypeClass.Applicative.html#c:applicative_ap/2","title":"Category.TypeClass.Applicative.applicative_ap/2","type":"callback","doc":""},{"ref":"Category.TypeClass.Applicative.html#t:t/1","title":"Category.TypeClass.Applicative.t/1","type":"type","doc":""},{"ref":"Category.TypeClass.Functor.html","title":"Category.TypeClass.Functor","type":"behaviour","doc":""},{"ref":"Category.TypeClass.Functor.html#<~/2","title":"Category.TypeClass.Functor.<~/2","type":"macro","doc":""},{"ref":"Category.TypeClass.Functor.html#fmap/2","title":"Category.TypeClass.Functor.fmap/2","type":"macro","doc":""},{"ref":"Category.TypeClass.Functor.html#c:functor_fmap/2","title":"Category.TypeClass.Functor.functor_fmap/2","type":"callback","doc":""},{"ref":"Category.TypeClass.Functor.html#~>/2","title":"Category.TypeClass.Functor.~>/2","type":"macro","doc":""},{"ref":"Category.TypeClass.Functor.html#t:t/1","title":"Category.TypeClass.Functor.t/1","type":"type","doc":""},{"ref":"Category.TypeClass.Monad.html","title":"Category.TypeClass.Monad","type":"behaviour","doc":""},{"ref":"Category.TypeClass.Monad.html#>>>/2","title":"Category.TypeClass.Monad.>>>/2","type":"macro","doc":""},{"ref":"Category.TypeClass.Monad.html#bind/2","title":"Category.TypeClass.Monad.bind/2","type":"macro","doc":""},{"ref":"Category.TypeClass.Monad.html#c:monad_bind/2","title":"Category.TypeClass.Monad.monad_bind/2","type":"callback","doc":""},{"ref":"Category.TypeClass.Monad.html#t:t/1","title":"Category.TypeClass.Monad.t/1","type":"type","doc":""},{"ref":"readme.html","title":"Category","type":"extras","doc":"Category Functors, Monads and Applicatives with real encapsulation"},{"ref":"readme.html#translation-table","title":"Category - Translation Table","type":"extras","doc":"Type ClassFunctionHaskellElixir Functorfmap&lt;$&gt;&lt;~ Functorflip fmap&lt;&amp;&gt;~&gt; Monadbind&gt;&gt;=&gt;&gt;&gt; Applicativeap&lt;*&gt;&lt;&lt;~"},{"ref":"readme.html#usage","title":"Category - Usage","type":"extras","doc":"As example of Functor, Monad and Applicative type classes usage we will consider classic sum type Maybe which implements all of them. Maybe is generic type which accepts one other type as parameter. It&#39;s very similar to List type in this meaning of parametricity: @type t :: [String.t] is List of strings, @type t :: Maybe.t(String.t) is Maybe String, @type t :: [a] is List of a, @type t :: Maybe.t(a) is Maybe a. Essence of Maybe is representation of optional values, so this data type have 2 constructors. Here is example of Maybe Integer type: iex&gt; use Category :ok iex&gt; j = Maybe.just(1) #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; n = Maybe.nothing() #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; Maybe.is?(j) true iex&gt; Maybe.is?(n) true There is significant difference between Maybe type @type t :: Maybe.t(integer) and more common in Elixir @type t :: nil | integer. As you can see, values Maybe.just(1) and Maybe.nothing() are values of the same type, which means that they can be composed efficiently. But values 1 and nil are values of different types (Integer and Atom), which means that they can&#39;t be composed efficiently. Let&#39;s consider examples of this efficient or inefficient compositions one by one."},{"ref":"readme.html#functor","title":"Category - Functor","type":"extras","doc":"Let&#39;s say we have value x of type Maybe.t(integer). And we have a function which accepts Integer and returns Integer, for example increment = &amp;(&amp;1 + 1). How do we apply increment to x? Without Maybe type code will look like this: case x do nil -&gt; x _ -&gt; increment.(x) end I can&#39;t say it is beautiful or convenient. But if we will use Maybe type which implements Functor behaviour, we can use fmap function (or its infix versions &lt;~ or ~&gt;) which will apply given function to internal state of Maybe in case of Maybe.just(a) or do nothing in case of Maybe.nothing. Final code will look much better: Functor.fmap(increment, x) or increment &lt;~ x or x ~&gt; increment Let&#39;s show how it works in iex: iex&gt; use Category :ok iex&gt; j = Maybe.just(1) #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; n = Maybe.nothing() #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; increment = &amp;(&amp;1 + 1) #Function&lt;6.128620087/1 in :erl_eval.expr/5&gt; iex&gt; increment &lt;~ j |&gt; Maybe.get! 2 iex&gt; increment &lt;~ n |&gt; Maybe.is_nothing? true Btw, as I mentioned before, List data type also implements Functor type class, and in reality every Elixir or Erlang developer already knows what is Functor and how it works, because map = fmap. So if you understand List data type and generic map function then you already understand Functors: iex&gt; Enum.map([1, 2, 3], &amp;(&amp;1 + 1)) [2, 3, 4]"},{"ref":"readme.html#applicative","title":"Category - Applicative","type":"extras","doc":"Applicative type class feels like some kind of generalization of Functor. Example is pretty similar to previous one. But in this case we have two values x and y of type Maybe.t(integer). And we have a function which accepts two integers and returns integer, for example sum = &amp;Kernel.+/2. How do we apply sum to x and y? Without Maybe code will look like: case is_nil(x) or is_nil(y) do true -&gt; nil false -&gt; sum.(x, y) end As you can see it looks ugly even with arity 2. Imagine how it will look with arity 10? But we can use Maybe. It implements Applicative behaviour which means that we can use ap (or its infix version &lt;&lt;~). We know how fmap applies function to Maybe value, ap is pretty similar - in our example it applies Maybe function to Maybe value. It&#39;s not so interesting itself (because there are not so many practical cases when we have Maybe function, right?), but it is very useful in combinations with fmap. Our final code will look like sum &lt;~ x &lt;&lt;~ y Let&#39;s show how it works in iex: iex&gt; use Category :ok iex&gt; x = Maybe.just(1) #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; y = Maybe.just(2) #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; n = Maybe.nothing() #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; sum = &amp;Kernel.+/2 &amp;:erlang.+/2 iex&gt; sum &lt;~ x &lt;&lt;~ y |&gt; Maybe.get! 3 iex&gt; sum &lt;~ x &lt;&lt;~ n |&gt; Maybe.is_nothing? true iex&gt; sum &lt;~ n &lt;&lt;~ y |&gt; Maybe.is_nothing? true In example above, sum function has arity 2, but of course we can compute functions with bigger arities using applicative notation, for example: iex&gt; use Category :ok iex&gt; f = fn x, y, z -&gt; x * x + y * y + z * z end #Function&lt;18.128620087/3 in :erl_eval.expr/5&gt; iex&gt; x = Maybe.just(1) #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; y = Maybe.just(2) #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; z = Maybe.just(3) #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; n = Maybe.nothing() #Function&lt;2.96330962/2 in Category.Data.Maybe.eval/2&gt; iex&gt; f &lt;~ x &lt;&lt;~ y &lt;&lt;~ z |&gt; Maybe.get! 14 iex&gt; f &lt;~ x &lt;&lt;~ n &lt;&lt;~ z |&gt; Maybe.is_nothing? true Btw, List data type also implements Applicative type class! In Elixir there is no direct equivalent like it was for fmap, but Applicative ap for List data type more or less corresponds to comprehensions like this: iex&gt; for f &lt;- [&amp;(&amp;1 + 1), &amp;(&amp;1 * 2)], x &lt;- [1, 2, 3], do: f.(x) [2, 3, 4, 2, 4, 6]"},{"ref":"readme.html#monad","title":"Category - Monad","type":"extras","doc":"Let&#39;s say we have a program which accepts Maybe Integer as input, but this program is able to work only with natural numbers. To make code safe, we have to use function like this: int2mnat = fn x when is_integer(x) and x &gt;= 0 -&gt; Maybe.just(x) _ -&gt; Maybe.nothing() end It completely make sense because there are no natural numbers corresponding to negative integers, so we have to use Maybe data type here. Function int2mnat accepts Integer and returns Maybe Natural as we want. But look, input of our program is Maybe Integer, not Integer, how do we deal with that? Without Monad type class, code will look like: case Maybe.is_just?(x) do true -&gt; x |&gt; Maybe.get! |&gt; int2mnat.() false -&gt; x end But as we know, Maybe implements Monad type class, so we can use bind function (or &gt;&gt;&gt; infix equivalent) to make code better: x &gt;&gt;&gt; int2mnat Let&#39;s show how it works in iex: iex&gt; use Category :ok iex&gt; int2mnat = fn ...&gt; x when is_integer(x) and x &gt;= 0 -&gt; Maybe.just(x) ...&gt; _ -&gt; Maybe.nothing() ...&gt; end #Function&lt;6.128620087/1 in :erl_eval.expr/5&gt; iex&gt; j0 = Maybe.just(1) #Function&lt;2.85804733/2 in Category.Data.Maybe.eval/2&gt; iex&gt; j1 = Maybe.just(-1) #Function&lt;2.85804733/2 in Category.Data.Maybe.eval/2&gt; iex&gt; n = Maybe.nothing() #Function&lt;2.85804733/2 in Category.Data.Maybe.eval/2&gt; iex&gt; j0 &gt;&gt;&gt; int2mnat |&gt; Maybe.get! 1 iex&gt; j1 &gt;&gt;&gt; int2mnat |&gt; Maybe.is_nothing? true iex&gt; n &gt;&gt;&gt; int2mnat |&gt; Maybe.is_nothing? true And as you already guessed, List data type also implements Monad type class! For List data type in Elixir, bind = flat_map: iex&gt; f = &amp;(&amp;1 &gt; 1 &amp;&amp; [&amp;1, &amp;1] || []) #Function&lt;6.128620087/1 in :erl_eval.expr/5&gt; iex&gt; Enum.flat_map([1, 2, 3], f) [2, 2, 3, 3] So if you know how flat_map works, you already understand monads!"},{"ref":"readme.html#installation","title":"Category - Installation","type":"extras","doc":"The package can be installed by adding category to your list of dependencies in mix.exs: def deps do [ {:category, &quot;~&gt; 0.1.0&quot;} ] end Made with ❤️ by Ilja Tkachuk aka timCF"}]